 ; MONITOR

.include "allgdef.inc"
.global	Monitor

Monitor:
	btsc	merker,#lcdaktiv
	return
	mov		monsta,w0
	bra		w0

	bra		monitor0
	bra		monitor1
	bra		monitor2
	bra		monitor3
	bra		monitor4
	bra		monitor5
	bra		monitor6
	bra		monitor7
	bra		monitor8
	bra		monitor9
	bra		monitor10
	bra		monitor11
	bra		monitor12
	bra		monitor13
	bra		monitor14
	bra		monitor15
	bra		monitor16
	bra		monitor17
	bra		monitor18
	
; Erster Teil, nur CNC ohne Laser
; XYZ-Positionen anzeigen mit Schriftgrsse #3
monitor0:
	mov		#weiss,w1
	mov		w1,hintergrund
	call	Tftclr
	mov		#3,w1				; Font
	mov		w1,schriftgroesse
	inc		monsta
	return
	

; Zeile 1 X-Position senden
monitor1:
	mov		#0,w1 				; Char-Position
	mov		w1,spalte
	mov		#0,w1         		; Zeile
	mov		w1,zeile
	mov		#21,w1
	mov		w1,nachunten
	mov		#20,w1
	mov		w1,nachrechts
	btsc	merker,#xistreset
	bra		monitor1a
	mov		#rot,w1
	mov		w1,schriftfarbe
	bra		monitor1b
monitor1a:
	mov		#schwarz,w0
	mov		w0,schriftfarbe		; -> schwarz
monitor1b:
	call	Holexposition		; -> (D)lcdpuffer
	mov		#lcdpuffer,w1
	mov		w1,lcdzgr
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 2 (dritte von oben) Y-Position senden
monitor2:
	mov		#0,w1 				; Char-Position
	mov		w1,spalte
	mov		#1,w1         		; Zeile
	mov		w1,zeile
	mov		#42,w1
	mov		w1,nachunten
	btsc	merker,#yistreset
	bra		monitor2a
	mov		#rot,w1
	mov		w1,schriftfarbe
	bra		monitor2b
monitor2a:
	mov		#schwarz,w0
	mov		w0,schriftfarbe		; -> schwarz
monitor2b:
	call	Holeyposition		; -> (D)lcdpuffer
	mov		#lcdpuffer,w1
	mov		w1,lcdzgr
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 3 (vierte von oben) Z-Position senden
monitor3:
	mov		#0,w1 				; Char-Position
	mov		w1,spalte
	mov		#2,w1         		; Zeile
	mov		w1,zeile
	mov		#63,w1
	mov		w1,nachunten
	btsc	merker,#zistreset
	bra		monitor3a
	mov		#rot,w1
	mov		w1,schriftfarbe
	bra		monitor3b
monitor3a:
	mov		#schwarz,w0
	mov		w0,schriftfarbe
monitor3b:
	call	Holezposition		; -> (D)lcdpuffer
	mov		#lcdpuffer,w1
	mov		w1,lcdzgr
	bset	merker,#lcdaktiv
	inc		monsta
	return

; ------------------------------------------------
; Laser-Modus?
; ------------------------------------------------
monitor4:
	btsc	inputdaten,#laserstecker
	bra		monitor4a
	mov		#1,w0
	mov		w0,monsta
	return
monitor4a:
	clr		nachrechts
	clr		nachunten
	mov		#12,w0
	mov		w0,leerzeilenzlr
	mov		#1,w0
	mov		w0,schriftgroesse
	mov		#weiss,w1
	mov		schriftfarbe
	inc		monsta
	return
	
; 20 leere Zeilen zum TFT, Char = 16 x 26
monitor5:
	dec		leerzeilenzlr
	cp0		leerzeilenzlr
	bra		nz,monitor5a
	inc		monsta
	return
monitor5a:
	mov		leerzeilenzlr,w0
	call	Leerzeile
	return

; ---------------------------------------
; 2. Teil: Anzeige im Laser-Modus
; ---------------------------------------

; ab hier Schriftgre = 1

; Zeile 0 = berschrift, 
monitor6:
	mov		#lcdpuffer,w8
	mov		w8,lcdzgr
	mov		#psvoffset(text1),w9
	call	Zeilexzumlcd
	mov		#0,w0
	mov		w0,zeile
	mov		#4,w0
	mov		w0,spalte
	mov		#schwarz,w0
	mov		w0,schriftfarbe
	mov		#12,w0
	mov		w0,nachunten
	bset	merker,#lcdaktiv
	inc		monsta
	return
	
; Zeile 2 = "Einstellungen:"
monitor7:
	mov		#lcdpuffer,w8
	mov		w8,lcdzgr
	mov		#psvoffset(text2),w9
	call	Zeilexzumlcd
	mov		#2,w0
	mov		w0,zeile
	mov		#2,w0
	mov		w0,spalte
	mov		#blau,w0
	mov		w0,schriftfarbe
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 3 = Linear 99%  Regler 99%
monitor8:
	mov		#lcdpuffer,w8
	mov		w8,lcdzgr
	mov		#psvoffset(text3),w9
	call	Zeilexzumlcd
	repeat	#13
	dec2	w8,w8					; Wegen der 0
	mov		linearpoti,w2
	call	Potistellung
	repeat	#8
	inc2	w8,w8
	mov     reglerpoti,w2
	call	Potistellung
	clr		[w8]
	mov		#3,w0
	mov		w0,zeile
	mov		#4,w0
	mov		w0,spalte
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 4 = "Laserkopf"
monitor9:
	mov		#lcdpuffer,w8
	mov		w8,lcdzgr
	mov		#psvoffset(text4),w9
	call	Zeilexzumlcd
	mov		#4,w0
	mov		w0,zeile
	mov		#2,w0
	mov		w0,spalte
	mov		#weiss,w0
	mov		w0,hintergrund
	mov		#10,w0
	add		nachunten
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 5 = "I=xxx%" 
monitor10:
	mov		#lcdpuffer,w8
	mov		w8,lcdzgr
 	mov		#psvoffset(text5),w9
 	call	Zeilexzumlcd
	dec2	w8,w8
	dec2	w8,w8
	mov		laserstrom,w2
	call	Potistellung
	clr		[w8]
	mov		#5,w0
	mov		w0,zeile
	mov		#4,w0
	mov		w0,spalte
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 5 = Betriebsart nach Schalter am Laserkopf
monitor11:
	mov		#lcdpuffer,w8
	mov		w8,lcdzgr
 	mov		#psvoffset(text6),w9
 	mov		laserkopfschalter,w0	; 0,1,2
 	mul.uu	w0,#6,w0
 	add		w9,w0,w9
 	call	Zeilexzumlcd
	clr		[w8]					; ende
	mov		lasersta,w0
	cp		w0,#1					; HAND?
	bra		nz,monitor11a
	mov		#blau,w0
	btss	merker,#handfertig
	mov		#rot,w0
	mov		w0,schriftfarbe
monitor11a:
	mov		#5,w0
	mov		w0,zeile
	mov		#12,w0
	mov		w0,spalte
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 5 = wo ist die Z-Achse
monitor12:
	mov		#lcdpuffer,w8
	mov		w8,lcdzgr
 	mov		#psvoffset(text9),w9
 	clr		w0
 	btsc	merker,#istoben
 	mov		#6,w0
 	btsc	merker,#istunten
 	mov		#12,w0
 	add		w9,w0,w9
 	call	Zeilexzumlcd
	clr		[w8]					; Wegen der 0
	mov		#5,w0
	mov		w0,zeile
	mov		#18,w0
	mov		w0,spalte
	mov		#blau,w0
	mov		w0,schriftfarbe
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 5 = CNC oder ???
monitor13:
	mov		#lcdpuffer,w8
	mov		w8,lcdzgr
 	mov		#psvoffset(text13),w9
 	btsc	inputdaten,#usbaktiv
 	mov		#psvoffset(text14),w9
 	call	Zeilexzumlcd
	clr		[w8]					; Wegen der 0
	mov		#5,w0
	mov		w0,zeile
	mov		#25,w0
	mov		w0,spalte
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 6 = Text "Position:"
monitor14:
	mov		#lcdpuffer,w8
	mov		w8,lcdzgr
	mov		#psvoffset(text12),w9
	call	Zeilexzumlcd
	mov		#6,w0
	mov		w0,zeile
	mov		#2,w0
	mov		w0,spalte
	mov		#10,w0
	add		nachunten
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 7 = X 123.45
monitor15:
	mov		#7,w0         		; Zeile
	mov		w0,zeile
	mov		#11,w0
	mov		w0,spalte
	btsc	merker,#xistreset
	bra		monitor15a
	mov		#rot,w0
	mov		w0,schriftfarbe
	bra		monitor15b
monitor15a:
	mov		#schwarz,w0
	mov		w0,schriftfarbe
monitor15b:
	call	Holexposition		; -> (D)lcdpuffer
	mov		#lcdpuffer,w1
	mov		w1,lcdzgr
	mov		#4,w0
	add		nachunten
	bset	merker,#lcdaktiv
	inc		monsta
	return
	
; Zeile 8 = Y 123.45
monitor16:
	mov		#8,w0         		; Zeile
	mov		w0,zeile
	mov		#11,w0
	mov		w0,spalte
	btsc	merker,#yistreset
	bra		monitor16a
	mov		#rot,w0
	mov		w0,schriftfarbe
	bra		monitor16b
monitor16a:
	mov		#schwarz,w0
	mov		w0,schriftfarbe
monitor16b:
	call	Holeyposition		; -> (D)lcdpuffer
	mov		#lcdpuffer,w1
	mov		w1,lcdzgr
	mov		#4,w0
	add		nachunten
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Zeile 9 = Z-Position
monitor17:
	mov		#9,w0         		; Zeile
	mov		w0,zeile
	mov		#11,w0
	mov		w0,spalte
	btsc	merker,#zistreset
	bra		monitor17a
	mov		#rot,w0
	mov		w0,schriftfarbe
	bra		monitor17b
monitor17a:
	mov		#schwarz,w0
	mov		w0,schriftfarbe
monitor17b:
	call	Holezposition		; -> (D)lcdpuffer
	mov		#lcdpuffer,w1
	mov		w1,lcdzgr
	mov		#4,w0
	add		nachunten
	bset	merker,#lcdaktiv
	inc		monsta
	return

; Laser-Modus beendet?
monitor18:
	btsc	inputdaten,#laserstecker
	bra		monitor18a
	clr		monsta
	return
monitor18a:
	mov		#6,w0
	mov		w0,monsta
	return

	
; ======================  UPs  ========================

; --------------------------------------------
; die X-Posions-Ascii-Text zum (D)lcdpuffer
; --------------------------------------------
Holexposition:
	mov		#'X',w1
	mov		w1,lcdpuffer
	mov		#' ',w1
	mov		w1,(lcdpuffer+2)
; negativ? dann nach postiv wandeln
	mov		#' ',w1
	mov		xzaehlerl,w4
	mov		xzaehlerh,w5
	btss	w5,#15			; neg?=
	bra		holexpos1		; pos!
	mov		#'-',w1
	com		w4,w4
	com		w5,w5
	add		w4,#1,w4
	addc	w5,#0,w5
holexpos1:
	mov		w1,lcdpuffer+4 	; - oder space	
; X durch 10.000 = 1/100tel mm, maximal 1869Fh = 999,99mm
	mov		#10000,w6
	call	Div32d16ist32	;W5,w4 durch W6 = W3,w2 (HW,NW)
; nach dezimal 99999 wandeln
	call	Bin17asc5		; w3,w2 --> w4,w3,w2,w1,w0
; zum (D)lcdpuffer
	call	Zumlcdpuffer
	return

; --------------------------------------------
; die Y-Posions-Ascii-Text zum (D)lcdpuffer
; --------------------------------------------
Holeyposition:
	mov		#'Y',w1
	mov		w1,lcdpuffer
	mov		#' ',w1
	mov		w1,(lcdpuffer+2)
; negativ? dann nach postiv wandeln
	mov		#' ',w1
	mov		yzaehlerl,w4
	mov		yzaehlerh,w5
	btss	w5,#15			; neg?=
	bra		holeypos1		; pos!
	mov		#'-',w1
	com		w4,w4
	com		w5,w5
	add		w4,#1,w4
	addc	w5,#0,w5
holeypos1:
	mov		w1,lcdpuffer+4 	; - oder space	
; X durch 10.000 = 1/100tel mm, maximal 1869Fh = 999,99mm
	mov		#10000,w6
	call	Div32d16ist32	;W5,w4 durch W6 = W3,w2 (HW,NW)
; nach dezimal 99999 wandeln
	call	Bin17asc5		; w3,w2 --> w4,w3,w2,w1,w0
; zum (D)lcdpuffer
	call	Zumlcdpuffer
	return
	
; --------------------------------------------
; die Z-Posions-Ascii-Text zum (D)lcdpuffer
; --------------------------------------------
Holezposition:
	mov		#'Z',w1
	mov		w1,lcdpuffer
	mov		#' ',w1
	mov		w1,lcdpuffer+2
; negativ? dann nach postiv wandeln
	mov		#' ',w1
	mov		zzaehlerl,w4
	mov		zzaehlerh,w5
	btss	w5,#15			; neg?=
	bra		holexpos1		; pos!
	mov		#'-',w1
	com		w4,w4
	com		w5,w5
	add		w4,#1,w4
	addc	w5,#0,w5
holezpos1:
	mov		w1,lcdpuffer+4 	; - oder space	
; X durch 10.000 = 1/100tel mm, maximal 1869Fh = 999,99mm
	mov		#10000,w6
	call	Div32d16ist32	;W5,w4 durch W6 = W3,w2 (HW,NW)
; nach dezimal 99999 wandeln
	call	Bin17asc5		; w3,w2 --> w4,w3,w2,w1,w0
; zum (D)lcdpuffer
	call	Zumlcdpuffer
	return
	
; ======================== UPs ======================

; eine leere Zeile 16x26 nach (D)lcdpuffer, 
; Eingang: Zeilen-Nr in W0
Leerzeile:
	mov		w0,zeile
	mov		#0,w0
	mov		w0,spalte
	mov		#lcdpuffer,w0
	mov		w0,lcdzgr
	mov		#0x20,w1
	repeat	#30
	mov		w1,[w0++]
	clr		[w0]
	clr		nachunten
	clr		nachrechts
	mov		#1,w0
	mov		w0,schriftgroesse
	bset	merker,#lcdaktiv
	return
	
; W4 bis W0 zum [w9], Abschluss mit 0x0
Zumlcdpuffer:
	mov		#lcdpuffer+6,w9
	mov		w4,[w9++]
	mov		w3,[w9++]
	mov		w2,[w9++]
	mov		#'.',w5
	mov		w5,[w9++]
	mov		w1,[w9++]
	mov		w0,[w9++]
	clr		w5
	mov		w5,[w9]
	return
	
; Eingang: (C)Textadresse in W9, 
; Ausgang: (D)zieladresse (D)lcdpuffer in W8
Zeilexzumlcd:
	mov		[w9],w2
	and		#0x00ff,w2
	mov		w2,[w8++]
	cp0		w2
	bra		z,zeilezumlcd1
	mov		[w9++],w2
	swap	w2
	and		#0x00ff,w2
	mov		w2,[w8++]
	cp0		w2
	bra		z,zeilezumlcd1
	bra		Zeilexzumlcd
zeilezumlcd1:
	return
	
; Daten in W2,(D)lcdpuffer in W8
; auf 99 begrenzt
Potistellung:
	cp0		w2
	bra		nz,potist0
	inc		w2,w2
potist0:
	mov		#10,w3
	repeat	#17
	div.u	w2,w3			; w0 = w3:w2
	cp		w0,#100			; ber 99?
	bra		lt,potist1
	mov		#100,w0
potist1:
	call	Bin16asc3		; w0 > w2,w1,w0
	mov		w2,[w8++]
	mov		w1,[w8++]
	mov		w0,[w8++]
	mov		#'%',w0
	mov		w0,[w8++]
	return
			

